Loading

HDU 5025:Saving Tang Monk(BFS + 状压)

http://acm.hdu.edu.cn/showproblem.php?pid=5025

 

Saving Tang Monk

 

Problem Description
 
《Journey to the West》(also 《Monkey》) is one of the Four Great Classical Novels of Chinese literature. It was written by Wu Cheng'en during the Ming Dynasty. In this novel, Monkey King Sun Wukong, pig Zhu Bajie and Sha Wujing, escorted Tang Monk to India to get sacred Buddhism texts. 

During the journey, Tang Monk was often captured by demons. Most of demons wanted to eat Tang Monk to achieve immortality, but some female demons just wanted to marry him because he was handsome. So, fighting demons and saving Monk Tang is the major job for Sun Wukong to do.

Once, Tang Monk was captured by the demon White Bones. White Bones lived in a palace and she cuffed Tang Monk in a room. Sun Wukong managed to get into the palace. But to rescue Tang Monk, Sun Wukong might need to get some keys and kill some snakes in his way.

The palace can be described as a matrix of characters. Each character stands for a room. In the matrix, 'K' represents the original position of Sun Wukong, 'T' represents the location of Tang Monk and 'S' stands for a room with a snake in it. Please note that there are only one 'K' and one 'T', and at most five snakes in the palace. And, '.' means a clear room as well '#' means a deadly room which Sun Wukong couldn't get in.

There may be some keys of different kinds scattered in the rooms, but there is at most one key in one room. There are at most 9 kinds of keys. A room with a key in it is represented by a digit(from '1' to '9'). For example, '1' means a room with a first kind key, '2' means a room with a second kind key, '3' means a room with a third kind key... etc. To save Tang Monk, Sun Wukong must get ALL kinds of keys(in other words, at least one key for each kind).

For each step, Sun Wukong could move to the adjacent rooms(except deadly rooms) in 4 directions(north, west, south and east), and each step took him one minute. If he entered a room in which a living snake stayed, he must kill the snake. Killing a snake also took one minute. If Sun Wukong entered a room where there is a key of kind N, Sun would get that key if and only if he had already got keys of kind 1,kind 2 ... and kind N-1. In other words, Sun Wukong must get a key of kind N before he could get a key of kind N+1 (N>=1). If Sun Wukong got all keys he needed and entered the room in which Tang Monk was cuffed, the rescue mission is completed. If Sun Wukong didn't get enough keys, he still could pass through Tang Monk's room. Since Sun Wukong was a impatient monkey, he wanted to save Tang Monk as quickly as possible. Please figure out the minimum time Sun Wukong needed to rescue Tang Monk.
 
Input
 
There are several test cases.

For each case, the first line includes two integers N and M(0 < N <= 100, 0<=M<=9), meaning that the palace is a N×N matrix and Sun Wukong needed M kinds of keys(kind 1, kind 2, ... kind M). 

Then the N × N matrix follows.

The input ends with N = 0 and M = 0.
 
Output
 
For each test case, print the minimum time (in minutes) Sun Wukong needed to save Tang Monk. If it's impossible for Sun Wukong to complete the mission, print "impossible"(no quotes).
 
Sample Input
 
3 1
K.S
##1
1#T
3 1
K#T
.S#
1#.
3 2
K#T
.S.
21.
0 0
 
Sample Output
 
5
impossible
8
 
题意:要从K走到T处,并且要先收集k把钥匙,收集钥匙顺序递增,即拿到第一把钥匙才能拿到第二把钥匙,还有不超过五条蛇(之前没看到这里只有五条不会做),每次打蛇要+1s,蛇死了再路过是不用打的。
思路:只有五条蛇,给蛇编号然后状压记录打的蛇的状态。剩下的就BFS。一开始用的优先队列,不过超时了。要注意vis数组记录状态的技巧!!!
 
 1 #include <cstdio>
 2 #include <cstring>
 3 #include <algorithm>
 4 #include <iostream>
 5 #include <queue>
 6 using namespace std;
 7 #define N 105
 8 #define INF 0x3f3f3f3f
 9 
10 struct node
11 {
12     int x, y, t, key, snake;
13     node() {}
14     node(int x, int y, int t, int key, int snake) : x(x), y(y), t(t), key(key), snake(snake) {}
15 };
16 bool vis[N][N][10][40];
17 int n, m, sx, sy, ex, ey;
18 int dx[] = {1, -1, 0, 0}, dy[] = {0, 0, 1, -1};
19 char maze[N][N];
20 
21 bool check(int x, int y)
22 {
23     if(0<=x&&x<n&&0<=y&&y<n&&maze[x][y]!='#') return true;
24     return false;
25 }
26 
27 void bfs()
28 {
29     int ans = INF;
30     memset(vis, 0, sizeof(vis));
31     queue<node> que;
32     while(!que.empty()) que.pop();
33     que.push(node(sx, sy, 0, 0, 0));
34     while(!que.empty()) {
35         node top = que.front(); que.pop();
36         int x = top.x, y = top.y, key = top.key, snake = top.snake, t = top.t;
37         if(key == m && maze[x][y] == 'T') {
38             ans = min(ans, t);
39         }
40         if(vis[x][y][key][snake] != 0) continue;
41         vis[x][y][key][snake] = 1;
42         for(int i = 0; i < 4; i++) {
43             int nx = x + dx[i], ny = y + dy[i];
44             if(!check(nx, ny)) continue;
45             node now = top;
46             if('A' <= maze[nx][ny] && maze[nx][ny] <= 'G') {
47                 //只有五条蛇,不能写 <= 'Z'
48                 int s = maze[nx][ny] - 'A';
49                 if((1<<s) & now.snake) ; //如果蛇被打了
50                 else {
51                     now.snake |= (1<<s); //没被打
52                     now.t++;
53                 }
54             } else if(maze[nx][ny] - '0' == now.key + 1) {
55                 now.key++;
56             }
57             now.t++;
58             que.push(node(nx, ny, now.t, now.key, now.snake));
59         }
60     }
61     if(ans != INF) printf("%d\n", ans);
62     else printf("impossible\n");
63 }
64 
65 int main()
66 {
67     while(~scanf("%d%d", &n, &m), n+m) {
68         int cnt = 0;
69         for(int i = 0; i < n; i++) {
70             scanf("%s", maze[i]);
71         }
72         for(int i = 0; i < n; i++) {
73             for(int j = 0; j < n; j++) {
74                 if(maze[i][j] == 'K') sx = i, sy = j;
75                 if(maze[i][j] == 'S') {maze[i][j] = cnt+'A'; cnt++;}
76             }
77         }
78         bfs();
79     }
80     return 0;
81 }
82 
83 /*
84 4 2
85 KS1.
86 2SS.
87 SSSS
88 STSS
89 0 0
90 */

 

posted @ 2016-08-12 12:15  Shadowdsp  阅读(1856)  评论(0编辑  收藏  举报